<?php
/*
/*
* Pixel Point Creative "Swift Slides Pro" Module for Joomla!
* License: GNU General Public License version 2
* See: http://www.gnu.org/copyleft/gpl.html
* Copyright (c) Pixel Point Creative LLC.
* More info at http://www.pixelpointcreative.com
* Review our terms/license here: http://pixelpointcreative.com/terms.html
*/
// no direct access
defined('_JEXEC') or die('Restricted access');
if (!class_exists('SwiftSlides')){
	class SwiftSlides extends Module{
		protected static $_instance = null;
		public function __construct($params=array()){
			$this->setParams($params);
		}
		public function getReader(){
			if (!isset($this->_reader)){
				$classReader = $this->getParams('reader');
					
				$class_name = __CLASS__;
				$class_name .= (null !== $classReader) ? $classReader : 'Reader';
					//var_dump($class_name); die("abc");
				if (!class_exists($class_name)){
					// load reader class file
					$filename = dirname(__FILE__) . DS . strtolower($class_name) . '.php';
					if (file_exists($filename)){
						include_once $filename;
					} else {
						throw new Exception("File not found: " . $filename);
					}
				}
				$this->_reader = new $class_name();
			}
			return $this->_reader;
		}
		public static function getInstance($params=array()){
			if (self::$_instance===null){
				$class_name = __CLASS__;
				self::$_instance = new $class_name($params);
			} else {
				self::$_instance->setParams($params);
			}
			return self::$_instance;
		}
		public static function getList($params=array()){
			return self::getInstance($params)->getItems();
		}
	}
}