<?php

/*

* Pixel Point Creative "Swift Slides Pro" Module for Joomla!

* License: GNU General Public License version 2

* See: http://www.gnu.org/copyleft/gpl.html

* Copyright (c) Pixel Point Creative LLC.

* More info at http://www.pixelpointcreative.com

* Review our terms/license here: http://pixelpointcreative.com/terms.html

*/

// no direct access

defined('_JEXEC') or die('Restricted access');

if (!class_exists('SwiftSlidesReader')){

	class SwiftSlidesReader extends Reader{

		public function getList(&$params){

			$list =array();

			$items=array();

			

						

            if($params['select_component'] == "0"){

                if(!empty($params['source'])){

    			$items = $this->content->getCategoryItems($params['source'], $params);

    			if(!empty($items)) {

                    include_once JPATH_SITE . DS . 'components' . DS . 'com_content' . DS . 'helpers' . DS . 'route.php';

                    $arrcustom_url=array();

    				$arrcustom_url = $this->_getCustomUrl($params['custom_url']);

    				foreach($items as $key => $item){

						

    					$temp = array();                       

    					if (!$this->content->getItemImage($item)){

                            $image_url = 'modules/'.Tools::getModule()->module . '/assets/images/nophoto.png';

    						$item->image = $image_url;

    					}

                        

    					if(array_key_exists($item->id, $arrcustom_url)){

    						$temp['link'] = $arrcustom_url[$item->id];

    					}else{

                            $this->content->getItemUrl($item);

    						$temp['link'] = $item->url;

    					}

                        $temp['id'] = $item->id;

						

						if (isset($params['item_title_max_characters']) && $params['item_title_max_characters'] > 0 && strlen($item->title) > $params['item_title_max_characters']) {

							$temp['title'] = substr($item->title, 0, $params['item_title_max_characters']) . '...';

						} else {

							$temp['title'] = $item->title;

						}

						$item->description = strip_tags($item->description);

						if (isset($params['item_desc_max_characters']) && $params['item_desc_max_characters'] > 0 && strlen($item->description) > $params['item_desc_max_characters']) {

							$temp['desc'] = substr($item->description, 0, $params['item_desc_max_characters']) . '...';

						} else {

							$temp['desc'] = $item->description;

						}

						

    					$temp['title'] = $item->title;

						//print_r($params);die;

						$image_config = array(

							'output_width'  => $params['item_image_width'],

							'output_height' => $params['item_image_height'],

							'function'		=> $params['item_image_function'],

							'background'	=> $params['item_image_background']

						);

						

    					$temp['image'] = Tools::resize($item->image,$image_config);

/*

    					if ((int)$params['item_desc_keephtml'] == 0){

    						$temp['desc'] = strip_tags($item->description);

    					} else {

    						$temp['desc'] = ($item->description);

    					}*/

    					

    					$list[] = $temp;

    

    				}

                } 

                }

            }else if($params['select_component'] == "1" && !empty($params['sourcek2'])){

                if(!empty($params['sourcek2'])){

                    if ($this->com_k2_installed()){

                        JLoader::register('K2Plugin', JPATH_ADMINISTRATOR.DS.'components'.DS.'com_k2'.DS.'lib'.DS.'k2plugin.php');

                        require_once (JPATH_SITE.DS.'components'.DS.'com_k2store'.DS.'helpers'.DS.'utilities.php');

                        require_once (JPATH_SITE.DS.'components'.DS.'com_k2store'.DS.'helpers'.DS.'cart.php');

                        require_once (JPATH_ADMINISTRATOR.DS.'components'.DS.'com_k2store'.DS.'library'.DS.'prices.php'); 

                    }                 

    			$items = $this->k2->getCategoryItems($params['sourcek2'], $params);
				
    			if(!empty($items)) {

    				require_once JPATH_SITE.'/components/com_k2/helpers/route.php';

                    $arrcustom_url=array();

    				$arrcustom_url = $this->_getCustomUrl($params['custom_url']);

    				foreach($items as $key => $item){

						

    					$temp = array();                       

    					if (!$this->k2->getItemImage($item)){

                            $image_url = 'modules/'.Tools::getModule()->module . '/assets/images/nophoto.png';

    						$item->image = $image_url;

    					}

                        

    					if(array_key_exists($item->id, $arrcustom_url)){

    						$temp['link'] = $arrcustom_url[$item->id];

    					}else{

                            $this->k2->getItemUrl($item);

    						$temp['link'] = $item->url;

    					}

                        $temp['id'] = $item->id;

    					//$temp['title'] = $item->title;

						

						if (isset($params['item_title_max_characters']) && $params['item_title_max_characters'] > 0 && strlen($item->title) > $params['item_title_max_characters']) {

							$temp['title'] = substr($item->title, 0, $params['item_title_max_characters']) . '...';

						} else {

							$temp['title'] = $item->title;

						}

						

						$image_config = array(

							'output_width'  => $params['item_image_width'],

							'output_height' => $params['item_image_height'],

							'function'		=> $params['item_image_function'],

							'background'	=> $params['item_image_background']

						);

						

    					$temp['image'] = Tools::resize($item->image,$image_config);

    					//$temp['image'] = $item->image;

                        if ($this->com_k2_installed()){

    						$config = JComponentHelper::getParams('com_k2store');

    						$show_tax = $config->get('show_tax_total','1');

    						$tax = K2StorePrices::getItemTax($item->id);

    						$price = K2StorePrices::getItemPrice($item->id);

    						if ($price > 0) {

    							$temp['price'] = K2StoreHelperCart::dispayPriceWithTax($price, $tax, $show_tax);

    						} 

                        }else {

    							$temp['price'] = '';

    					}      
						if (isset($item->description) && $item->description != '') {
							$item->description = strip_tags($item->description);
						} else if (isset($item->description1) && $item->description1 != '') {
							$item->description = strip_tags($item->description1);
						}
						
						if (isset($params['item_desc_max_characters']) && $params['item_desc_max_characters'] > 0 && strlen($item->description) > $params['item_desc_max_characters']) {

							$temp['desc'] = substr($item->description, 0, $params['item_desc_max_characters']) . '...';

						} else {

							$temp['desc'] = $item->description;

						}               

    					/*if ((int)$params['item_desc_keephtml'] == 0){

    						$temp['desc'] = strip_tags($item->description);

    					} else {

    						$temp['desc'] = ($item->description);

    					}*/

    					$list[] = $temp;

    				}

                }

            }

            }

			return $list;

		}

		private function _getCustomUrl($custom_url) {

			$arrUrl = array();

			$tmp = explode("\n", trim($custom_url));

			foreach( $tmp as $strTmp){

				$pos = strpos($strTmp, ":");

				if($pos >=0){

					$tmpKey = substr($strTmp, 0, $pos);

					$key = trim($tmpKey);

					$tmpLink = substr($strTmp, $pos+1, strlen($strTmp)-$pos);

					$haveHttp =  strpos(trim($tmpLink), "http://");

					if($haveHttp<0 || ($haveHttp !== false) ){

						$link = trim($tmpLink);

					}else{

						$link = "http://" . trim($tmpLink);

					}

					$arrUrl[$key] = $link;

				}

			}

			return $arrUrl;

		}

        

    	protected function com_k2_installed(){

    		$db = &JFactory::getDbo();

    		$prefix = $db->getPrefix();

    		$tables = $db->getTableList();

    		return in_array($prefix.'k2store_address', $tables);

    	}

            

	}

}