<?php
/*
* Pixel Point Creative "Swift Slides Pro" Module for Joomla!
* License: GNU General Public License version 2
* See: http://www.gnu.org/copyleft/gpl.html
* Copyright (c) Pixel Point Creative LLC.
* More info at http://www.pixelpointcreative.com
* Review our terms/license here: http://pixelpointcreative.com/terms.html
*/
// no direct access
defined('_JEXEC') or die('Restricted access');
defined('_TOOLS') or die;
if (!class_exists('Module')){
	abstract class Module {
		protected $_params = null;
		protected $_items  = null;
		protected $_reader = null;
		abstract function getReader();
		abstract static function getList();
		abstract static function getInstance();
		public function setParams($params){
			if ($params instanceof JRegistry) {
				$params = $params->toArray();
			}
			$this->_params = $params;
		}
		public function getParams($key=null){
			if (is_null($key)){
				return $this->_params;
			} else {
				if (isset($this->_params[$key])){
					return $this->_params[$key];
				}
				return null;
			}
		}
		protected function getItems(){
			if (is_null($this->_items)){
				$this->_items = array();
			}
			$identify = md5(serialize($this->_params));
			if (!isset($this->_items[$identify])){
				$this->_items[$identify] = $this->getReader()->getList($this->_params);
			}
			return $this->_items[$identify];
		}
	}
}