<?php

/*

* Pixel Point Creative "Swift Slides Pro" Module for Joomla!

* License: GNU General Public License version 2

* See: http://www.gnu.org/copyleft/gpl.html

* Copyright (c) Pixel Point Creative LLC.

* More info at http://www.pixelpointcreative.com

* Review our terms/license here: http://pixelpointcreative.com/terms.html

*/

// no direct access

defined('_JEXEC') or die('Restricted access');

// load *.css



$doc = &JFactory::getDocument();

$uniqued='refine_slide_'.rand().time();

$options=$params->toObject();



$image_items_config = array(

		'output_width'  => $params->get('item_image_width'),

		'output_height' => $params->get('item_image_height'),

		'function'	=> $params->get('item_image_function'),

		'background'	=> $params->get('item_image_background')

	);

$thumb_width = $params->get( 'item_image_width', 250 );

$thumb_height = $params->get( 'item_image_height', 250 );

$mod_height = $params->get('mod_height', 400);

$mod_width = $thumb_width * sizeof($items);

$active_item = $params->get('active_item', 1);
if ($active_item < 0) {
	$active_item = 0;
}

$target = $params->get('item_link_target', '');

$color = $params->get('title_color', '#FFFFFF');
$keep_active = $params->get('keep_active', '1');

$cospan = 3;

$cospan_mobile = 4;

$no_active_width = floor(99 / (sizeof($items) + $cospan - 1));

$mod_height_mobile = $params->get('mod_height_mobile', 400);

$no_active_height = floor($mod_height_mobile / (sizeof($items) + $cospan_mobile));



$enable_link = $params->get( 'enable_link', 1 );

$css = '#swiftslides' . $module->id . ' { height: '. $params->get('mod_height', 400) .'px;}';

$css .= '#swiftslides' . $module->id . ' .accordion li { width: '. $no_active_width .'%; height: '. $mod_height .'px;} ';

$css .= '#swiftslides_hoz' . $module->id . ' .accordion_hoz li { width: 100%; height: '. $no_active_height .'px;} ';



$css .= '#swiftslides' . $module->id . ' li .description { width: 100%;} ';

$css .= '#swiftslides_hoz' . $module->id . ' li .description { width: 100%;} ';



$doc->addStyleDeclaration($css);

/*print '<pre>';

 print_r($items);

 die;*/



 if (!empty($items)) {

?>

<div id="swiftslides<?php echo $module->id?>" class="swiftslides">

<ul class="accordion" id="accordion<?php echo $module->id?>">

	<?php 

	$css = '';

    foreach ($items as $key => $item){

		$more_class = '';

		if (($active_item -1) == $key  && $keep_active == 1) {

			$css .= 'ul#accordion'. $module->id .' li.bg' . $key . '{   background-image:url('. $item['image'] .'); width: '. ($no_active_width * $cospan) .'%; }';

			$more_class .= ' active';

		} else {		

			$css .= 'ul#accordion'. $module->id .' li.bg' . $key . '{  background-image:url('. $item['image'] .') }';

		}

		//$more_class = '';

		if ($key == (sizeof($items) - 1)) {

			$more_class .= ' bleft';

		}

		if (isset($item['target']) && $item['target'] != '') {
			$target = $item['target'];
		}

    	?>

		<li class="bg<?php echo $key;?> <?php echo $more_class;?>">
			<?php if ($item['title'] != '' && $params->get('show_caption') == 1):?>
			<div class="heading"><?php echo $item['title'];?></div>
			<?php endif; ?>
			<?php if ($params->get('show_caption') == 1 || $params->get('show_desc') == 1 || $params->get('show_readmore') == 1):?>
			<?php if ($item['title'] != '' || $item['desc'] != ''):?>
			<div class="bgDescription"></div>
			<?php endif;?>
			<div class="description">

				<?php if ($params->get('show_caption') == 1): ?><h2><?php echo $item['title'];?></h2> <?php endif; ?>

				<?php if ($params->get('show_desc') == 1): ?><p><?php echo $item['desc'];?></p><?php endif; ?>

				<?php if ($params->get('show_readmore') == 1 && $item['link'] != ''): ?><a href="<?php echo $item['link']?>" target="<?php echo $target;?>"><?php echo $params->get('readmore_text', JTEXT::_('READ MORE'));?> &rarr;</a><?php endif; ?>

			</div>
			<?php endif; ?>
		</li>       

    	<?php } ?>

		

	

</ul>

</div>

<?php

$doc->addStyleDeclaration($css);

?>

<script type="text/javascript">

	jQuery(document).ready(function() {
		<?php if ($keep_active) { ?>
			jQuery('.heading',jQuery('#accordion<?php echo $module->id?> li.active')).stop(true,true).fadeOut();
	
			jQuery('.description',jQuery('#accordion<?php echo $module->id?> li.active')).stop(true,true).slideDown(250);
	
			jQuery('.bgDescription',jQuery('#accordion<?php echo $module->id?> li.active')).stop(true,true).fadeIn();
		<?php } ?>
		jQuery('#accordion<?php echo $module->id?> > li').hover(

			function () {

				var $this = jQuery(this);

				//Setting Remove Active
				//console.log($this.attr("class"));
				<?php if ($keep_active) { ?>
					if ($this.attr("class").indexOf('active') == -1) { 		
				<?php } ?>	
					<?php if ($keep_active) { ?>
 						jQuery('#accordion<?php echo $module->id?> li.active').animate({'width':'<?php echo $no_active_width;?>%'},250);					
					
						jQuery('.heading',jQuery('#accordion<?php echo $module->id?> li.active')).stop(true,true).fadeIn();
		
						jQuery('.description',jQuery('#accordion<?php echo $module->id?> li.active')).stop(true,true).fadeOut();
		
						jQuery('.bgDescription',jQuery('#accordion<?php echo $module->id?> li.active')).stop(true,true).slideUp();
		
						
					<?php } ?>
					
					jQuery('#accordion<?php echo $module->id?> li').removeClass('active');
					$this.stop().animate({'width':'<?php echo ($no_active_width * $cospan);?>%'},250);
	
					jQuery('.heading',$this).stop(true,true).fadeOut();
	
					jQuery('.bgDescription',$this).stop(true,true).slideDown(250);
	
					jQuery('.description',$this).stop(true,true).fadeIn();
		
					$this.addClass('active');
				<?php if ($keep_active) { ?>
				}
				<?php } ?>
			},

			function () {

				var $this = jQuery(this);
				<?php if (!$keep_active) { ?>
					$this.stop().animate({'width':'<?php echo $no_active_width;?>%'},250);
	
					jQuery('.heading',$this).stop(true,true).fadeIn();
	
					jQuery('.description',$this).stop(true,true).fadeOut(250);
	
					jQuery('.bgDescription',$this).stop(true,true).slideUp(500);
				<?php } ?>
 
			}

		);

	});

</script>

<div id="swiftslides_hoz<?php echo $module->id?>" class="swiftslides_hoz">

<ul class="accordion_hoz" id="accordion_hoz<?php echo $module->id?>">

	<?php 

	$css = '';

    foreach ($items as $key => $item){

	

		$more_class = '';

		if (($active_item -1) == $key && $keep_active == 1) {

			$css .= 'ul#accordion_hoz'. $module->id .' li.bg' . $key . '{  background-image:url('. $item['image'] .'); height: '. ($no_active_height * $cospan_mobile) .'px;  }';

			$more_class .= ' active';

		} else {

			$css .= 'ul#accordion_hoz'. $module->id .' li.bg' . $key . '{  background-image:url('. $item['image'] .') }';

		}

		

		if ($key == (sizeof($items) - 1)) {

			$more_class .= ' bleft';

		}

		

    	?>

		<li class="bg<?php echo $key;?> <?php echo $more_class;?>">
			<?php if ($item['title'] != '' && $params->get('show_caption') == 1):?>
			<div class="heading"><?php echo $item['title'];?></div>
			<?php endif; ?>
			<?php if ($params->get('show_caption') == 1 || $params->get('show_desc') == 1 || $params->get('show_readmore') == 1):?>
			<?php if ($item['title'] != '' || $item['desc'] != ''):?>
			<div class="bgDescription"></div>
			<?php endif; ?>
			<div class="description">
				<?php if ($params->get('show_caption') == 1): ?><h2><?php echo $item['title'];?></h2> <?php endif; ?>

				<?php if ($params->get('show_desc') == 1): ?><p><?php echo $item['desc'];?></p><?php endif; ?>

				<?php if ($params->get('show_readmore') == 1 && $item['link'] != ''): ?><a href="<?php echo $item['link']?>" target="<?php echo $target;?>"><?php echo $params->get('readmore_text', JTEXT::_('READ MORE'));?> &rarr;</a><?php endif; ?>
				
				

			</div>
			<?php endif; ?>
		</li>       

    	<?php } ?>

		

	

</ul>

</div>

<?php

$doc->addStyleDeclaration($css);

?>

<script type="text/javascript">

	jQuery(document).ready(function() {

		jQuery('.heading',jQuery('#accordion_hoz<?php echo $module->id?> li.active')).stop(true,true).fadeOut();

		jQuery('.description',jQuery('#accordion_hoz<?php echo $module->id?> li.active')).stop(true,true).slideDown(500);

		jQuery('.bgDescription',jQuery('#accordion_hoz<?php echo $module->id?> li.active')).stop(true,true).fadeIn();

		jQuery('#accordion_hoz<?php echo $module->id?> > li').hover(

			function () {

				var $this = jQuery(this);
				<?php if ($keep_active) { ?>
				if ($this.attr("class").indexOf('active') == -1) { 
				<?php } ?>
					jQuery('#accordion_hoz<?php echo $module->id?> li.active').animate({'height':'<?php echo $no_active_height;?>px'},500);
	
					//Setting Remove Active
				<?php if ($keep_active) { ?>
					jQuery('.heading',jQuery('#accordion_hoz<?php echo $module->id?> li.active')).stop(true,true).fadeIn();
	
					jQuery('.description',jQuery('#accordion_hoz<?php echo $module->id?> li.active')).stop(true,true).fadeOut();
	
					jQuery('.bgDescription',jQuery('#accordion_hoz<?php echo $module->id?> li.active')).stop(true,true).slideUp();
	
					jQuery('#accordion_hoz<?php echo $module->id?> li').removeClass('active');	
					<?php } ?>
					
	
					$this.stop().animate({'height':'<?php echo ($no_active_height * $cospan_mobile);?>px'},500);
	
					jQuery('.heading',$this).stop(true,true).fadeOut();
	
					jQuery('.bgDescription',$this).stop(true,true).slideDown(500);
	
					jQuery('.description',$this).stop(true,true).fadeIn();
		
					$this.addClass('active');
				<?php if ($keep_active) { ?>
				}
				<?php } ?>

			},

			function () {

				var $this = jQuery(this);
				<?php if (!$keep_active) { ?>
					$this.stop().animate({'height':'<?php echo $no_active_height;?>px'},500);
	
					jQuery('.heading',$this).stop(true,true).fadeIn();
	
					jQuery('.description',$this).stop(true,true).fadeOut(500);
	
					jQuery('.bgDescription',$this).stop(true,true).slideUp(700);
				<?php } ?>
			}

		);

	});

</script>

<?php } ?>  